#define com_maroontress_libcgi_Request_IMPORT
#define com_maroontress_libcgi_mime_ContentType_IMPORT
#define com_maroontress_libcgi_request_GetRequest_IMPORT
#define com_maroontress_libcgi_request_PostRequest_IMPORT
#define std_io_OutputTube_IMPORT

#include <stdlib.h>
#include <string.h>
#include <com/maroontress/libcgi/Request.h>
#include <com/maroontress/libcgi/mime/ContentType.h>
#include <com/maroontress/libcgi/request/GetRequest.h>
#include <com/maroontress/libcgi/request/PostRequest.h>
#include <std/io/OutputTube.h>

struct Request *
Request_create(void)
{
    const char *requestMethod;

    if ((requestMethod = getenv("REQUEST_METHOD")) == NULL)
	return NULL;
    if (strcmp(requestMethod, "GET") == 0)
	return GetRequest_create();
    if (strcmp(requestMethod, "POST") == 0)
	return PostRequest_create();
    return NULL;
}

char *
Request_getValue(struct Request *r, const char *name)
{
    if (Request_getContentType(r, name) != NULL)
	return NULL;
    return r->methods->getValue(r->impl, name);
}

struct ContentType *
Request_getContentType(struct Request *r, const char *name)
{
    return r->methods->getContentType(r->impl, name);
}

int
Request_writeValue(struct Request *r, const char *name, union OutputTube out)
{
    return r->methods->writeValue(r->impl, name, out);
}

void
Request_free(struct Request *r)
{
    if (r == NULL)
	return;
    r->methods->free(r->impl);
}

void
Request_initialize(struct Request *r, const struct Request_Methods *methods,
		   union Request_Impl *impl)
{
    r->methods = methods;
    r->impl = impl;
}
